URLTemplateLoader (FreeMarker 2.3.23 API)
Date: 2015-07-05

freemarker.cache

## Class URLTemplateLoader

- java.lang.Object
- - freemarker.cache.URLTemplateLoader

- All Implemented Interfaces:
    TemplateLoader
  Direct Known Subclasses:
    ClassTemplateLoader

      public abstract class URLTemplateLoader
      extends Object
      implements TemplateLoader

  This is an abstract template loader that can load templates whose location can be described by an URL. Subclasses only need to override the `getURL(String)` method. Both `ClassTemplateLoader` and `WebappTemplateLoader` are (quite trivial) subclasses of this class.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `URLTemplateLoader()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static String` | `canonicalizePrefix(String prefix)` Can be used by subclasses to canonicalize URL path prefixes.
    `void` | `closeTemplateSource(Object templateSource)` Closes the template source, releasing any resources held that are only required for reading the template and/or its metadata.
    `Object` | `findTemplateSource(String name)` Finds the template in the backing storage and returns an object that identifies the storage location where the template can be loaded from.
    `long` | `getLastModified(Object templateSource)` Returns the time of last modification of the specified template source.
    `Reader` | `getReader(Object templateSource, String encoding)` Returns the character stream of a template represented by the specified template source.
    `protected abstract URL` | `getURL(String name)` Given a template name (plus potential locale decorations) retrieves an URL that points the template source.
    `Boolean` | `getURLConnectionUsesCaches()` Getter pair of `setURLConnectionUsesCaches(Boolean)`.
    `void` | `setURLConnectionUsesCaches(Boolean urlConnectionUsesCaches)` Sets if `URLConnection.setUseCaches(boolean)` will be called, and with what value.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### URLTemplateLoader

          public URLTemplateLoader()

  - ### Method Detail

    - #### findTemplateSource

          public Object findTemplateSource(String name)
                                    throws IOException

      Description copied from interface: `TemplateLoader`
      Finds the template in the backing storage and returns an object that identifies the storage location where the template can be loaded from. See the return value for more information.
      Specified by:
        `findTemplateSource` in interface `TemplateLoader`
      Parameters:
        `name` - The name of the template, already localized and normalized by the `cache`. It is completely up to the loader implementation to interpret the name, however it should expect to receive hierarchical paths where path components are separated by a slash (not backslash). Backslashes (or any other OS specific separator character) are not considered as separators by FreeMarker, and thus they will not be replaced with slash before passing to this method, so it's up to the template loader to handle them (say, be throwing and exception that tells the user that the path (s)he has entered is invalid, as (s)he must use slash -- typical mistake of Windows users). The passed names are always considered relative to some loader-defined root location (often referred as the "template root directory"), and will never start with a slash, nor will they contain a path component consisting of either a single or a double dot -- these are all resolved by the template cache before passing the name to the loader. As a side effect, paths that trivially reach outside template root directory, such as `../my.ftl`, will be rejected by the template cache, so they never reach the template loader. Note again, that if the path uses backslash as path separator instead of slash as (the template loader should not accept that), the normalization will not properly happen, as FreeMarker (the cache) recognizes only the slashes as separators.
      Returns:
        An object representing the template source, which can be supplied in subsequent calls to `TemplateLoader.getLastModified(Object)` and `TemplateLoader.getReader(Object, String)`, when those are called on the same `TemplateLoader`. `null` must be returned if the source for the template doesn't exist; don't throw exception then! The exact type of this object is up to the `TemplateLoader` implementation. As this object is possibly used as hash key in caches, and is surly compared with another template source for equality, it must have a proper `Object.equals(Object)` and `Object.hashCode()`) implementation. Especially, template sources that refer to the same physical source must be equivalent, otherwise template caching can become inefficient. This is only expected from `Object.equals(Object)` when the compared template sources came from the same `TemplateLoader` instance. Also, it must not influence the equality if the source is open or closed (`TemplateLoader.closeTemplateSource(Object)`).
      Throws:
        `IOException` - When an error occurs that makes it impossible to find out if the template exists, or to access the existing template. Don't throw exception if the template doesn't exist, instead return with `null` then!

    - #### getURL

          protected abstract URL getURL(String name)

      Given a template name (plus potential locale decorations) retrieves an URL that points the template source.
      Parameters:
        `name` - the name of the sought template, including the locale decorations.
      Returns:
        an URL that points to the template source, or null if it can determine that the template source does not exist.

    - #### getLastModified

          public long getLastModified(Object templateSource)

      Description copied from interface: `TemplateLoader`
      Returns the time of last modification of the specified template source. This method is called after `findTemplateSource()`.
      Specified by:
        `getLastModified` in interface `TemplateLoader`
      Parameters:
        `templateSource` - an object representing a template source, obtained through a prior call to `TemplateLoader.findTemplateSource(String)`. This must be an object on which `TemplateLoader.closeTemplateSource(Object)` wasn't applied yet.
      Returns:
        the time of last modification of the specified template source, or -1 if the time is not known.

    - #### getReader

          public Reader getReader(Object templateSource,
                                  String encoding)
                           throws IOException

      Description copied from interface: `TemplateLoader`
      Returns the character stream of a template represented by the specified template source. This method is possibly called for multiple times for the same template source object, and it must always return a `Reader` that reads the template from its beginning. Before this method is called for the second time (or later), its caller must close the previously returned `Reader`, and it must not use it anymore. That is, this method is not required to support multiple concurrent readers for the same source `templateSource` object.

      Typically, this method is called if the template is missing from the cache, or if after calling `TemplateLoader.findTemplateSource(String)` and `TemplateLoader.getLastModified(Object)` it was determined that the cached copy of the template is stale. Then, if it turns out that the `encoding` parameter used doesn't match the actual template content (based on the `#ftl encoding=...` header), this method will be called for a second time with the correct `encoding` parameter value.

      Specified by:
        `getReader` in interface `TemplateLoader`
      Parameters:
        `templateSource` - an object representing a template source, obtained through a prior call to `TemplateLoader.findTemplateSource(String)`. This must be an object on which `TemplateLoader.closeTemplateSource(Object)` wasn't applied yet.
        `encoding` - the character encoding used to translate source bytes to characters. Some loaders may not have access to the byte representation of the template stream, and instead directly obtain a character stream. These loaders should ignore the encoding parameter.
      Returns:
        A `Reader` representing the template character stream. It's the responsibility of the caller (which is `TemplateCache` usually) to `close()` it. The `Reader` is not required to work after the `templateSource` was closed (`TemplateLoader.closeTemplateSource(Object)`).
      Throws:
        `IOException` - if an I/O error occurs while accessing the stream.

    - #### closeTemplateSource

          public void closeTemplateSource(Object templateSource)
                                   throws IOException

      Description copied from interface: `TemplateLoader`
      Closes the template source, releasing any resources held that are only required for reading the template and/or its metadata. This is the last method that is called by the `TemplateCache` for a template source, except that `Object.equals(Object)` is might called later too. `TemplateCache` ensures that this method will be called on every object that is returned from `TemplateLoader.findTemplateSource(String)`.
      Specified by:
        `closeTemplateSource` in interface `TemplateLoader`
      Parameters:
        `templateSource` - the template source that should be closed.
      Throws:
        `IOException`

    - #### canonicalizePrefix

          protected static String canonicalizePrefix(String prefix)

      Can be used by subclasses to canonicalize URL path prefixes.
      Parameters:
        `prefix` - the path prefix to canonicalize
      Returns:
        the canonicalized prefix. All backslashes are replaced with forward slashes, and a trailing slash is appended if the original prefix wasn't empty and didn't already end with a slash.

    - #### getURLConnectionUsesCaches

          public Boolean getURLConnectionUsesCaches()

      Getter pair of `setURLConnectionUsesCaches(Boolean)`.
      Since:
        2.3.21

    - #### setURLConnectionUsesCaches

          public void setURLConnectionUsesCaches(Boolean urlConnectionUsesCaches)

      Sets if `URLConnection.setUseCaches(boolean)` will be called, and with what value. By default this is `null`; see the behavior then below. The recommended value is `false`, so that FreeMarker can always reliably detect when a template was changed. The default is `null` only for backward compatibility, and certainly will be changed to `false` in 2.4.0. As FreeMarker has its own template cache with its own update delay setting (`Configuration.setTemplateUpdateDelay(int)`), setting this to `false` shouldn't cause performance problems.

      Regarding `null` value: By default then `URLConnection.setUseCaches(boolean)` won't be called, and so the default of the `URLConnection` subclass will be in effect (usually `true`). That's the 2.3.0-compatible mode. However, if `Configuration.getIncompatibleImprovements()` is at least 2.3.21, then when `Configuration.getTemplate` is used, `null` will mean `false`. Note that this 2.3.21 trick only works if the template is loaded through `Configuration.getTemplate` (or `TemplateCache`).

      Since:
        2.3.21